
/*****************************************************************************
**
** File:        mqwrapback.c
** Purpose:     Natural Interface for MQSeries
** Description: MQBACK function
**
** (c) Copyright 2000 by IBM
**
*****************************************************************************/

#include <stdio.h>
#include <stdlib.h>             /* Memory and type conversions */
#include <string.h>             /* strcpy stuff */
#include <ctype.h>              /* is upper stuff */
#include <time.h>               /* time of course */
#include <errno.h>              /* contains errno , last error indicator */
#include <fcntl.h>              /* FILE I/O related protos and defines */
#include <limits.h>		/* FILE I/O related protos and defines */
#include <io.h>             /* defines for file access              */
#include <sys/types.h>          /* for data types sycj as time          */
#include <sys/stat.h>           /* finding out status info              */

#include "cmqc.h"		        /* MQ Headers		*/
#include "natuser.h"	    	/* Natural User Exit	*/
#include "namq.h"               /* MQ interface function prototypes */

NATFCT NAMQBACK NATARGDEF(nparm, parmptr, parmdec)
{
#ifdef MQBACK_DEBUG
  static char * func = "NAMQBACK : "	;
#endif

  MQHCONN	con_hndl	;
  MQBO   	begin_options	;
  MQLONG 	cc		;
  MQLONG 	rc 		;

  /*
  ** test number of arguments
  */
  if (nparm != 4)
       {
#ifdef MQBACK_DEBUG
    		printf("\n%s Not ENough Parameters!" ,func) ;
#endif
		return 1;
  	 }


  /*
  ** move Con hndl from Natural to Local variable
  */

  memmove ((char *) &con_hndl, (char *) parmptr[0], sizeof(MQHCONN));

  /*
  ** Call the back out routine
  */

  mq_back ( con_hndl, &cc, &rc);

#ifdef MQBACK_DEBUG
  printf("\n%s handle = %d cc is %d , rc = %d ", func , con_hndl , cc , rc ) ;
#endif

  /*
  ** move Condition Code to Natural Return block
  */

  memmove ((char *) parmptr[1], (char *) &cc, sizeof(MQLONG));

  /*
  ** move Return Code to Natural Return block
  */

  memmove ((char *) parmptr[2], (char *) &rc, sizeof(MQLONG));

  return 0;

} /* MQBACK */




/*
***********************************************************************
			mq_back
***********************************************************************
*/

void mq_back (MQHCONN con_hndl, MQLONG *cc, MQLONG *rc)
{
#ifdef MQBACK_DEBUG
  static char * func = "mq_back : "	;
#endif

    MQBACK(con_hndl, cc , rc) ;

#ifdef MQBACK_DEBUG
    if ( *cc == MQCC_FAILED)
	{
	   printf("%s Failed to Back out a transaction\n",func);
	}
#endif

    return ;

}


