
/*****************************************************************************
**
** File:        mqwrapdisconnect.c
** Purpose:     Natural Interface for MQSeries
** Description: MQDISC function
**
** (c) Copyright 2000 by IBM
**
*****************************************************************************/

#include <stdio.h>
#include <stdlib.h>             /* Memory and type conversions */
#include <string.h>             /* strcpy stuff */
#include <ctype.h>              /* is upper stuff */
#include <time.h>               /* time of course */
#include <errno.h>              /* contains errno , last error indicator */
#include <fcntl.h>              /* FILE I/O related protos and defines */
#include <limits.h>		/* FILE I/O related protos and defines */
#include <io.h>             /* defines for file access              */
#include <sys/types.h>          /* for data types sycj as time          */
#include <sys/stat.h>           /* finding out status info              */

#include "cmqc.h"		        /* MQ Headers		*/
#include "natuser.h"	    	/* Natural User Exit	*/
#include "namq.h"               /* MQ interface function prototypes */

NATFCT NAMQDISC NATARGDEF(nparm, parmptr, parmdec)
{
#ifdef MQDISC_DEBUG
  static char * func = "NAMQDISC : "	;
#endif

  MQHCONN	con_hndl	;
  MQLONG 	cc		;
  MQLONG 	rc 		;

  /*
  ** test number of arguments
  */
  if (nparm != 3)
       {
#ifdef MQDISC_DEBUG
    		printf("\n%s Not Enough Parameters!" , func ) ;
#endif
		return 1;
  	 }

  /*
  ** move Con handle from Natural to Local variable
  */

  memmove ((char *) &con_hndl, (char *) parmptr[0], sizeof(MQHCONN));

#ifdef MQDISC_DEBUG
  printf("\n%s con handle = '%d' ", func , con_hndl ) ;
#endif

  /*
  ** Call the Disconnect routine
  */

  mq_disconnect ( &con_hndl, &cc, &rc);

#ifdef MQDISC_DEBUG
  printf("\n%s cc is %d , rc = %d ", func, cc , rc ) ;
#endif

  /*
  ** move Handle to Natural Return block
  */

  memmove ((char *) parmptr[0], (char *) &con_hndl, sizeof(MQHCONN));

  /*
  ** move Condition Code to Natural Return block
  */

  memmove ((char *) parmptr[1], (char *) &cc, sizeof(MQLONG));

  /*
  ** move Return Code to Natural Return block
  */

  memmove ((char *) parmptr[2], (char *) &rc, sizeof(MQLONG));

  return 0;

} /* NAMQDISC */


/*
***********************************************************************
		mq_disconnect
***********************************************************************
*/

void mq_disconnect (MQHCONN * con_hndl, MQLONG *cc, MQLONG *rc)
{
#ifdef MQDISC_DEBUG
  static char * func = "mq_disconnect : "	;
#endif


     MQDISC(con_hndl, cc, rc);

#ifdef MQDISC_DEBUG
     if ( *cc  != MQCC_OK)
	{
		printf("\n%s cc is %d , rc = %d ", func, cc , rc ) ;
	}
#endif

    return ;

}

